
/******************************************************************************
* MODULE     : keyw_return.cc
* DESCRIPTION: The 'return' keyword
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <gentable.hh>
namespace mmx {

void
evaluator_rep::kw_return_1 () {
  CHECK_SYNC (MMX_RETURN);
  if (N(car(trace)) == 1) {
    cur= KW_RETURN_2;
    rem= cons (VAL_NONE, rem);
    kw_return_2 ();
  }
  else evaluate_arg (car(trace)[1], KW_RETURN_2);
}

void
evaluator_rep::kw_return_2 () {
  CHECK_SYNC (MMX_RETURN);
  // INPUT: (return_2, ret_val, cont, ...)
  if (env->contains (CONT_RETURN)) {
    list l= as_list (env [CONT_RETURN]);
    // CONTINUATION: (old_env, old_trace, old_cont, ...)
    env= as_gentable (car (l));
    cur= caddr (l);
    rem= cons (car (rem), cdddr (l));
    // OUTPUT: (old_cont, ret_val, ...)
    trace= cdr (as_list (cadr (l)));
  }
  else error (car(trace), "Not inside a function");
}

} // namespace mmx
