
/******************************************************************************
* MODULE     : keyw_while.cc
* DESCRIPTION: while statement in loops
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <single.hh>
#include <xtable.hh>
namespace mmx {

void
evaluator_rep::kw_while_1 () {
  CHECK_SYNC (MMX_LOOP);
  // INPUT: (while_1, cond, other_conds, first_pass?, cont, ...)
  if (as_bool (as_value (car (rem)) -> val)) {
    cur= KW_LOOP_2;
    rem= cdr (rem);
    // OUTPUT: (loop_2, cond_list, first_pass?, cont, ...)
  }
  else {
    env= as_xtable (env)->base_t;
    cur= cadddr (rem);
    rem= cons (VAL_NONE, cddddr (rem));
    // OUTPUT: (cont, void, ...)
    trace= cdr (trace);
  }
}

} // namespace mmx
